#!/usr/bin/python
# encoding: utf-8
# filename: analisadorDePublicacoes.py
#
#  scriptLattes V8
#  Copyright 2005-2012: Jesús P. Mena-Chalco e Roberto M. Cesar-Jr.
#  http://scriptlattes.sourceforge.net/
#
#
#  Este programa é um software livre; você pode redistribui-lo e/ou 
#  modifica-lo dentro dos termos da Licença Pública Geral GNU como 
#  publicada pela Fundação do Software Livre (FSF); na versão 2 da 
#  Licença, ou (na sua opnião) qualquer versão.
#
#  Este programa é distribuido na esperança que possa ser util, 
#  mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAÇÂO a qualquer
#  MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a
#  Licença Pública Geral GNU para maiores detalhes.
#
#  Você deve ter recebido uma cópia da Licença Pública Geral GNU
#  junto com este programa, se não, escreva para a Fundação do Software
#  Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#


import string
import re
import urllib2

class AnalisadorDePublicacoes:
	grupo = None
	paises = None
	listaDePublicacoesEinternacionalizacao = None

	def __init__(self, grupo):
		self.grupo = grupo
		self.listaDePublicacoesEinternacionalizacao = []
		self.paises =  ["afghanistan", "akrotiri", "albania", "algeria", "american samoa", "andorra", "angola", "anguilla", "antarctica", "antigua and barbuda", "argentina", "armenia", "aruba", "ashmore and cartier islands", "australia", "austria", "azerbaijan", "bahamas", "bahrain", "bangladesh", "barbados", "bassas da india", "belarus", "belgium", "belize", "benin", "bermuda", "bhutan", "bolivia", "bosnia and herzegovina", "botswana", "bouvet island", "brazil", "british indian ocean territory", "british virgin islands", "brunei", "bulgaria", "burkina faso", "burma", "burundi", "cambodia", "cameroon", "canada", "cape verde", "cayman islands", "central african republic", "chad", "chile", "china", "christmas island", "clipperton island", "cocos islands", "colombia", "comoros", "congo", "cook islands", "coral sea islands", "costa rica", "cote divoire", "croatia", "cuba", "cyprus", "czech republic", "denmark", "dhekelia", "djibouti", "dominica", "dominican republic", "east timor ", "ecuador", "egypt", "el salvador", "equatorial guinea", "eritrea", "estonia", "ethiopia", "europa island", "falkland islands", "faroe islands", "federated states of micronesia", "fiji", "finland", "france", "french guiana", "french polynesia", "gabon", "gambia", "gaza strip", "georgia", "germany", "ghana", "gibraltar", "glorioso islands", "greece", "greenland", "grenada", "guadeloupe", "guam", "guatemala", "guernsey", "guinea", "guinea-bissau", "guyana", "haiti", "heard island and mcdonald islands", "honduras", "hong kong", "hungary", "iceland", "india", "indonesia", "iran", "iraq", "ireland", "isle of man", "israel", "italy", "jamaica", "jan mayen", "japan", "jersey", "jordan", "juan de nova island", "kazakhstan", "kenya", "kiribati", "kosovo", "kuwait", "kyrgyzstan", "laos", "latvia", "lebanon", "lesotho", "liberia", "libya", "libyan arab jamahiriya", "liechtenstein", "lithuania", "luxembourg", "macau", "macedonia", "madagascar", "malawi", "malaysia", "maldives", "mali", "malta", "marshall islands", "martinique", "mauritania", "mauritius", "mayotte", "mexico", "micronesia", "moldova", "monaco", "mongolia", "montenegro", "montserrat", "morocco", "mozambique", "myanmar ", "namibia", "nauru", "navassa island", "nepal", "netherlands", "new caledonia", "new zealand", "nicaragua", "niger", "nigeria", "niue", "norfolk island", "north america", "north korea", "northern mariana islands", "norway", "oceania", "oman", "pakistan", "palau", "palestinian territory", "panama", "papua new guinea", "paracel islands", "paraguay", "peru", "philippines", "pitcairn islands", "poland", "portugal", "puerto rico", "qatar", "reunion", "romania", "russia", "rwanda", "saint barthelemy", "saint helena", "saint kitts and nevis", "saint lucia", "saint martin", "saint pierre and miquelon", "saint vincent and the grenadines", "saint-pierre and miquelon", "samoa", "san marino", "sao tome and principe", "saudi arabia", "senegal", "serbia", "serbia and montenegro", "seychelles", "sierra leone", "singapore", "slovakia", "slovenia", "solomon islands", "somalia", "south africa", "south georgia and the south sandwich islands", "south korea", "south sudan", "spain", "spratly islands", "sri lanka", "sudan", "suriname", "svalbard", "swaziland", "sweden", "switzerland", "syria", "syrian arab republic", "taiwan", "tajikistan", "tanzania", "thailand", "timor-leste", "togo", "tokelau", "tonga", "trinidad and tobago", "tromelin island", "tunisia", "turkey", "turkmenistan", "turks and caicos islands", "tuvalu", "uganda", "ukraine", "united arab emirates", "united kingdom", "united states", "uruguay", "usa", "uzbekistan", "vanuatu", "vatican", "venezuela", "vietnam", "virgin islands", "wake island", "wallis and futuna", "west bank", "western sahara", "yemen", "zambia", "zimbabwe"]



	def analisarInternacionalizacaoNaCoautoria(self):
		listaCompletaPB = self.grupo.compilador.listaCompletaPB

		keys = listaCompletaPB.keys()
		for ano in keys:
			elementos = listaCompletaPB[ano]
			for index in range(0, len(elementos)):
				pub = elementos[index]
				if hasattr(pub, 'doi'):
					if not pub.doi=="":
						indiceDePaises = self.identificarPaisesEmPublicacao(pub.doi)
						print pub.doi
						print indiceDePaises
			

		# devolve uma lista com as publicacoes e paises
		return self.listaDePublicacoesEinternacionalizacao

	def identificarPaisesEmPublicacao(self, urlDOI):
		doihtml = self.obterDadosAtravesDeDOI(urlDOI)
		doihtml = doihtml.lower()
		# - retirar os acentos? 
		# - procurar paises em outras linguas (brasil...)

		listaDePaisesIdentificados = []
		for index in range(0,len(self.paises)):
			if re.search(r"\b" + re.escape(self.paises[index]) + r"\b", doihtml):
				listaDePaisesIdentificados.append(index)
				# print self.paises[index]
		return listaDePaisesIdentificados


	def obterDadosAtravesDeDOI(self, urlDOI):
		txdata = None
		txheaders = {   
		'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64; rv:2.0) Gecko/20100101 Firefox/4.0',
		'Accept-Language': 'en-us,en;q=0.5',
		'Accept-Encoding': 'deflate',
		'Keep-Alive': '115',
		'Connection': 'keep-alive',
		'Cache-Control': 'max-age=0',
		}

		req = urllib2.Request(urlDOI, txdata, txheaders)
		arquivoH = urllib2.urlopen(req) 
		rawDOIhtml = arquivoH.read()
		arquivoH.close()

		#
		#print "ANTES ========================================================="
		#print rawDOIhtml

		depurador = DepuradorDOIhtml(rawDOIhtml)
		doihtml = depurador.obterDadosDaPublicacao()
			
		#print "===== HTML - inicio ========================================================="
		#print doihtml
		#print "===== HTML - fim ============================================================"

		return doihtml


from HTMLParser import HTMLParser
from tidylib import tidy_document
from htmlentitydefs import name2codepoint


class DepuradorDOIhtml(HTMLParser):
	dadosDaPublicacao = None
	textoValido = None

	def __init__(self, rawDOIhtml):
		HTMLParser.__init__(self)
		self.dadosDaPublicacao = ""
		self.textoValido = 1

		rawDOIhtml, errors = tidy_document(rawDOIhtml, options={'numeric-entities':1})
		self.feed(rawDOIhtml)


	def handle_starttag(self, tag, attributes):
		#self.item = ""

		if tag=='a':
			for name, value in attributes:
				if name=='href' and '.pdf' in value.lower():
					print ">>>>>>>>>>>:" + value


	#def handle_endtag(self, tag):
	#	if self.item.strip()=="Abstract":
	#		self.textoValido = 0

	def handle_data(self, dado):
		self.item = htmlentitydecode(dado)

		if self.textoValido == 1:
			self.dadosDaPublicacao = self.dadosDaPublicacao + self.item

	def obterDadosDaPublicacao(self):
		return stripBlanks(self.dadosDaPublicacao)


# ---------------------------------------------------------------------------- #
def stripBlanks(s):
	return re.sub('\s+', ' ', s).strip()

def htmlentitydecode(s):                                                                               
	return re.sub('&(%s);' % '|'.join(name2codepoint),                                                 
		lambda m: unichr(name2codepoint[m.group(1)]), s)   

